package com.its.op.service.its.scrs;

import com.its.op.dao.repository.its.scrs.TbScPstnIxrMngmRepository;
import com.its.op.dto.its.scrs.TbScPstnIxrMngmDto;
import com.its.op.entity.its.scrs.TbScPstnIxrMngm;
import com.its.op.entity.its.scrs.TbScPstnIxrMngmKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbScPstnIxrMngmService {

    private final TbScPstnIxrMngmRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbScPstnIxrMngm requireOne(TbScPstnIxrMngmKey ixrGrop) throws NoSuchElementException {
        Optional<TbScPstnIxrMngm> info = this.repo.findById(ixrGrop);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + ixrGrop);
        }
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScPstnIxrMngmDto> findAll() {
        List<TbScPstnIxrMngmDto> result = new ArrayList<>();
        List<TbScPstnIxrMngm> data = this.repo.findAll();
        for (TbScPstnIxrMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScPstnIxrMngmDto> findAllList() {
        List<TbScPstnIxrMngmDto> result = new ArrayList<>();
        List<TbScPstnIxrMngm> data = this.repo.findAllList();
        for (TbScPstnIxrMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbScPstnIxrMngmDto findById(TbScPstnIxrMngmKey ixrGrop) {
        TbScPstnIxrMngm entity = requireOne(ixrGrop);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbScPstnIxrMngmDto updateById(TbScPstnIxrMngmKey ixrGrop, TbScPstnIxrMngmDto.TbScPstnIxrMngmUpdReq req) {
        TbScPstnIxrMngm entity = requireOne(ixrGrop);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbScPstnIxrMngmDto> mergeInfoList(List<TbScPstnIxrMngmDto.TbScPstnIxrMngmUpdReq> reqList) {
        List<TbScPstnIxrMngmDto> result = new ArrayList<>();
        for (TbScPstnIxrMngmDto.TbScPstnIxrMngmUpdReq req : reqList) {
            TbScPstnIxrMngm obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbScPstnIxrMngmDto mergeInfo(TbScPstnIxrMngmDto.TbScPstnIxrMngmUpdReq req) {
        TbScPstnIxrMngm obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbScPstnIxrMngmDto deleteById(TbScPstnIxrMngmKey ixrGrop) {
        TbScPstnIxrMngm entity = requireOne(ixrGrop);
        this.repo.deleteById(ixrGrop);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbScPstnIxrMngmDto> deleteByIds(List<TbScPstnIxrMngmKey> ids) {
        List<TbScPstnIxrMngmDto> result = new ArrayList<>();
        for (TbScPstnIxrMngmKey id : ids) {
            Optional<TbScPstnIxrMngm> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
